#include <exec/lists.h>
#include <dos/dos.h>
#include <stdlib.h>
#include <string.h>

#include <clib/exec_protos.h>
#include <clib/dos_protos.h>
#include <clib/alib_protos.h>

struct List *CreateListFromPattern(char *pattern, char *directory);

/* stellt fest, ob eine Datei vorliegt */
BOOL IsFile(struct FileInfoBlock *fib)
{
   return ((fib->fib_DirEntryType == ST_FILE) ||
       (fib->fib_DirEntryType == ST_LINKFILE) ||
       (fib->fib_DirEntryType == ST_SOFTLINK));
}

/* alloziert einen Listen-Kopf und initialisiert in */
struct List *AllocList(void)
{  struct List *l;

   if (l = (struct List *)calloc(1,sizeof(struct List)))
   {  NewList(l); }
   return l;
}

/* alloziert ein Listen-Element und initialisiert es */
struct Node *AllocNode(char *name)
{  struct Node *n;
   char *namebuf;

   if (n = (struct Node *)calloc(1,sizeof(struct Node)))
   {  if (namebuf = (char *)malloc(strlen(name)+1))
      {  strcpy(namebuf,name);
         n->ln_Name = namebuf;
      } else {  n = 0L; }
   }
   return n;
}

#define namelen    255

struct List *CreateListFromPattern(char *pattern, char *directory)
{
   struct List *list = 0L;
   struct Node *node;
   BPTR lock;                 /* fr Lock(directory)      */
   struct AnchorPath *AP = 0; /* Struktur fr MatchXxx()  */

   if (lock = Lock(directory,SHARED_LOCK))
   {  lock = CurrentDir(lock);
      if (list = AllocList())
      {  if (AP = calloc(1,sizeof(*AP)+namelen))
         {  AP->ap_BreakBits = SIGBREAKF_CTRL_C;
            AP->ap_Strlen    = namelen;

            if (MatchFirst(pattern,AP) == DOSFALSE)
            {  do
               {  if (IsFile(&(AP->ap_Info)))
                  {  if (node = AllocNode(AP->ap_Buf))
                     {  AddTail(list,node); }
                  }
               } while (MatchNext(AP) == DOSFALSE);

               MatchEnd(AP);
            }
            free(AP);
         }
         else list = 0L;
      }
      lock = CurrentDir(lock);
      UnLock(lock);
   }
   return list;
}

